#!/usr/bin/env bash
set -Eeuo pipefail

cd "$(dirname "$(readlink -f "$BASH_SOURCE")")/specs"

versions=( "$@" )
if [ ${#versions[@]} -eq 0 ]; then
    versions=( */ )
fi
versions=( "${versions[@]%/}" )

suites=( "alpine3.12" "alpine3.17" )

generated_warning() {
	cat <<-EOH
		#
		# NOTE: THIS DOCKERFILE IS GENERATED VIA "update.sh"
		#
		# PLEASE DO NOT EDIT IT DIRECTLY.
		#

	EOH
}

gitlabSteps=
for version in "${versions[@]}"; do
    rcVersion="${version%-rc}"

    majorVersion="${rcVersion%%.*}"
    minorVersion="${rcVersion#$majorVersion.}"
    minorVersion="${minorVersion%%.*}"

    apiUrl="https://pypi.org/rss/project/ansible/releases.xml"
    apiXqExpr='
        .rss
        | .channel
        | .item[]
        | select(.title | startswith("'"$rcVersion"'."))
        | [
            .title
        ]
    '

    if [ "$rcVersion" != "$version" ]; then
        apiXqExpr='
            .rss
            | .channel
            | .item[]
            | select(.title | startswith("'"$rcVersion"'.") and contains("'"rc"'") )
            | [
                .title
            ]
        '
    fi
    IFS=$'\n'
    possibles=( $(
        curl -fsSL "$apiUrl" \
            | xq --raw-output "$apiXqExpr | @sh" \
            | sort -rV
    ) )
    unset IFS

    if [ "${#possibles[@]}" -eq 0 ]; then
        echo >&2
        echo >&2 "error: unable to determine available releases of $version"
        echo >&2
        echo "skipping: $version"
        continue
    fi

    # format of "possibles" array entries is "VERSION"
    eval "possi=( ${possibles[0]} )"
    fullVersion="${possi[0]}"

    dockerfiles=()

    for suite in "${suites[@]}"; do
        [ -s "$version/$suite" ] || continue
        alpineVer="${suite#alpine}"

        baseDockerfile=Dockerfile-debian.template
        if [ "${suite#alpine}" != "$suite" ]; then
            baseDockerfile=Dockerfile-alpine.template
        fi

        for variant in base; do
            { generated_warning; cat "../templates/$baseDockerfile"; } > "$version/$suite/$variant/Dockerfile"

            echo "Generating $version/$suite/Dockerfile from $baseDockerfile + $variant-Dockerfile-block-*"
            gawk -i inplace -v variant="$variant" '
                $1 == "##</autogenerated>##" { ia = 0 }
                !ia { print }
                $1 == "##<autogenerated##" { ia = 1; ab++; ac = 0; if (system("test -f ../templates/" variant "-Dockerfile-block-" ab) != 0) { ia = 0 } }
                ia { ac++ }
                ia && ac == 1 { system("cat ../templates/" variant "-Dockerfile-block-" ab) }
            ' "$version/$suite/$variant/Dockerfile"

            echo -n "$fullVersion" > "$version/$suite/$variant/VERSION"
#            cp -a \
#                ../templates/docker-ansible-entrypoint \
#                "$version/$suite/$variant/"

            # remove any _extra_ blank lines created by the deletions above
			gawk '
				{
					if (NF == 0 || (NF == 1 && $1 == "\\")) {
						blank++
					}
					else {
						blank = 0
					}

					if (blank < 2) {
						print
					}
				}
			' "$version/$suite/$variant/Dockerfile" > "$version/$suite/$variant/Dockerfile.new"
			mv "$version/$suite/$variant/Dockerfile.new" "$version/$suite/$variant/Dockerfile"

			sed -ri \
				-e 's!%%DEBIAN_TAG%%!'"$suite-slim"'!' \
				-e 's!%%DEBIAN_SUITE%%!'"$suite"'!' \
				-e 's!%%ALPINE_VERSION%%!'"$alpineVer"'!' \
				"$version/$suite/$variant/Dockerfile"
			dockerfiles+=( "$version/$suite/$variant/Dockerfile" )
        done
    done

    (
        set -x
        sed -ri \
            -e 's!%%ANSIBLE_VERSION%%!'"$fullVersion"'!' \
            "${dockerfiles[@]}"
    )

#    for dockerfile in "${dockerfiles[@]}"; do
#        cmd="$(awk '$1 == "CMD" { $1 = ""; print }' "$dockerfile" | tail -1 | jq --raw-output '.[0]')"
#        entrypoint="$(dirname "$dockerfile")/docker-ansible-entrypoint"
#        sed -i 's! ansible ! '"$cmd"' !g' "$entrypoint"
#    done

    for dockerfile in "${dockerfiles[@]}"; do
		dir="${dockerfile%Dockerfile}"
		dir="${dir%/}"
		variant="${dir#$version}"
		variant="${variant#/}"
		newGitlabStep="\nbuild $version $variant:\n    extends:\n        - .docker-image-build\n    variables:\n        VERSION: '$version'\n        VARIANT: '$variant'"
	done
	gitlabSteps="$gitlabSteps$newGitlabStep"
done

gitlabCi=$(echo "$gitlabSteps" | awk '{gsub(/\\n/, "\n")}1')
echo "$gitlabCi" > ../.gitlab/docker-images.yml
